###############################################
#repack assets menu sxos by Reacher17 #
# Thanks to the following: 
# Chronoss
# B&ender, Heykyz, mrdude
###############################################
from Crypto.Cipher import AES
from Crypto.Util import Counter
import os
import hashlib
import struct
from binascii import hexlify as _hexlify, unhexlify
import subprocess
import sys
import pip

reqs = subprocess.check_output([sys.executable, '-m', 'pip', 'freeze'])
installed_packages = [r.decode().split('==')[0] for r in reqs.split()]

#print(installed_packages, "\n")

def install():
    try:
        if not ('pycryptodome' in installed_packages):
            pip.main(['install', "pycryptodome"])
            #subprocess.run(['pip', 'install', 'pycryptodome'])
        if not ('pycryptodomex' in installed_packages):
            pip.main(['install', "pycryptodome"])
            #subprocess.run(['pip', 'install', 'pycryptodomex'])
    
    except OSError as e:
        print("Error: %s %s" % ("during package install,", e.strerror))

install()

boot = 'boot.dat'


f = open(boot, "rb")
b = f.read()
f.close()


def hexlify(b: (bytes, bytearray)) -> str:
    return _hexlify(b).decode("utf8")

def aes_ctr_dec(buf, key, iv):
    hex_val = (iv.hex())
    ctr = Counter.new(128, initial_value=int(hex_val, 16))
    return AES.new(key, AES.MODE_CTR, counter=ctr).encrypt(buf)




bootloader_key = unhexlify("FB61357AB9DEE1C9D4C49F6488349EF0")
bootloader_ctr = unhexlify("5BCF60493E61BCB930FD44C7FAC0EE09")
assets_key = unhexlify("EF48639FC925C8D0364B2DA7614EB038")
assets_ctr = unhexlify("7298408E70FBE048DCC6E594B0C272B6")
payload81_key = unhexlify("12280A64B7A487E99864CD2E22393C87")
payload81_ctr = unhexlify("C28124EAA147BEE8EF865E2AE8496834")
fb_key = unhexlify("4599F62BF51E62B6AC05AAA7E7B03DE3")
fb_ctr = unhexlify("39B0F6E0846C53DCE0457F285797AE99")
s2_key = unhexlify("47E6BFB05965ABCD00E2EE4DDF540261")
s2_ctr = unhexlify("8E4C7889CBAE4A3D64797DDA84BDB086")
s3_key = unhexlify("D548D48DBA299604CED1AE5B47D8429C")
s3_ctr = unhexlify("428DB51A85E4940D37648FEC66BA2C78")
fw_key = unhexlify("81F555CC58EF03CB41BD81C90A8E8F79")
fw_ctr = unhexlify("A4C122884E6C8979E3E3E0F07D116E52")

patch_s2 = unhexlify("00008052C0035FD6")


header = 'header.bin'
bootbin = 'boot.bin'
stage2 = 'stage2_40008100.bin'
stage3 = 'stage3_40020000.bin'
payload81 = 'payload_81000000.bin'
rommenu = 'rommenu.bin'
bootloader = 'bootloader_88000000.bin'
assets = 'assets_8804A000.bin'
fb = 'fb_F0000000.bin'

f = open(boot, "rb")
bootin = f.read()

bootout = open(bootbin, "wb")
bootout.write(bootin)

#assets_8804A000.bin
assets_tmp = open(assets, "wb")
assets_tmp.write(aes_ctr_dec(bootin[0x600DE0:0x600DE0+0x4DC400], assets_key, assets_ctr))
if os.path.isfile('out/menu_bg.bin'):
 tmp = open('out/menu_bg.bin', "rb")
 GFX = tmp.read()
 tmp.close()
 assets_tmp.seek(0x400)
 assets_tmp.write(GFX)
if os.path.isfile('out/options.bin'):
 tmp = open('out/options.bin', "rb")
 GFX = tmp.read()
 tmp.close()
 assets_tmp.seek(0x400400)
 assets_tmp.write(GFX)
if os.path.isfile('out/bootcfw.bin'):
 tmp = open('out/bootcfw.bin', "rb")
 GFX = tmp.read()
 tmp.close()
 assets_tmp.seek(0x440400)
 assets_tmp.write(GFX)
if os.path.isfile('out/bootofw.bin'):
 tmp = open('out/bootofw.bin', "rb")
 GFX = tmp.read()
 tmp.close()
 assets_tmp.seek(0x480400)
 assets_tmp.write(GFX)
if os.path.isfile('out/launch.bin'):
 tmp = open('out/launch.bin', "rb")
 GFX = tmp.read()
 tmp.close()
 assets_tmp.seek(0x4C0400)
 assets_tmp.write(GFX)
if os.path.isfile('out/poweroff.bin'):
 tmp = open('out/poweroff.bin', "rb")
 GFX = tmp.read()
 tmp.close()
 assets_tmp.seek(0x4C4400)
 assets_tmp.write(GFX)
if os.path.isfile('out/repair.bin'):
 tmp = open('out/repair.bin', "rb")
 GFX = tmp.read()
 tmp.close()
 assets_tmp.seek(0x4C8400)
 assets_tmp.write(GFX)
if os.path.isfile('out/autorcm.bin'):
 tmp = open('out/autorcm.bin', "rb")
 GFX = tmp.read()
 tmp.close()
 assets_tmp.seek(0x4CC400)
 assets_tmp.write(GFX)
if os.path.isfile('out/emunand.bin'):
 tmp = open('out/emunand.bin', "rb")
 GFX = tmp.read()
 tmp.close()
 assets_tmp.seek(0x4D0400)
 assets_tmp.write(GFX)
if os.path.isfile('out/nand.bin'):
 tmp = open('out/nand.bin', "rb")
 GFX = tmp.read()
 tmp.close()
 assets_tmp.seek(0x4D4400)
 assets_tmp.write(GFX)
if os.path.isfile('out/core.bin'):
 tmp = open('out/core.bin', "rb")
 GFX = tmp.read()
 tmp.close()
 assets_tmp.seek(0x4D8400)
 assets_tmp.write(GFX)
 
assets_tmp.seek(0x0)

with open(assets, 'rb') as f:
 bytes = f.read()
 sha256_assets = hashlib.sha256(bytes).hexdigest()
print("assets hash:", sha256_assets)

bootout.seek(0x600DE0)
bootout.write(aes_ctr_dec(bytes, assets_key, assets_ctr))
assets_tmp.close()
#------------------

#bootloader_88000000.bin
BL = open(bootloader, "wb")
BL.write(aes_ctr_dec(bootin[0x5B6DE0:0x5B6DE0+0x4A000], bootloader_key, bootloader_ctr))
BL.seek(0x47E40)
BL.write(unhexlify(sha256_assets))
BL.seek(0x0)
with open(bootloader, 'rb') as f:
 bytes = f.read()
 sha256_bl = hashlib.sha256(bytes).hexdigest()
print("bootloader hash:", sha256_bl)

bootout.seek(0x5B6DE0)
bootout.write(aes_ctr_dec(bytes, bootloader_key, bootloader_ctr))
BL.close()
#------------------
#payload80000000.bin
pay81 = open(payload81, "wb")
pay81.write(aes_ctr_dec(bootin[0x201E0:0x1F6DE0], payload81_key, payload81_ctr))
#sha256 booloader
pay81.seek(0x1C9FE8)
pay81.write(unhexlify(sha256_bl))
pay81.seek(0x0)

with open(payload81, 'rb') as f:
    bytes = f.read()
    sha256_pay81 = hashlib.sha256(bytes).hexdigest()  
print("payload 81 hash:", sha256_pay81)

bootout.seek(0x201E0)
bootout.write(aes_ctr_dec(bytes, payload81_key, payload81_ctr))
#------------------
#fb F0000000.bin

if os.path.isfile('out/splash.bin'):
 fb_in = open(fb, "wb")
 fb_in.write(aes_ctr_dec(bootin[0x1F6DE0:0x1F6DE0+0x3C0000], fb_key, fb_ctr))
 
 tmp = open('out/splash.bin', "rb")
 FB_splash = tmp.read()
 tmp.close()
 
 fb_in.seek(0x0)
 fb_in.write(FB_splash)
 fb_in.seek(0x0)

 with open(fb, 'rb') as f:
     bytes = f.read()
     sha256_fb = hashlib.sha256(bytes).hexdigest()
 print("fb hash:", sha256_fb)

 bootout.seek(0x1F6DE0)
 bootout.write(aes_ctr_dec(bytes, fb_key, fb_ctr))
 fb_in.close()
 os.remove("fb_F0000000.bin")
#------------------
#stage3 40020000.bin
stage3_in = open(stage3, "wb")
stage3_in.write(aes_ctr_dec(bootin[0x11500:0x1BB70], s3_key, s3_ctr))
if os.path.isfile('out/splash.bin'):
 stage3_in.seek(0xA5D0)
 stage3_in.write(unhexlify(sha256_fb))
stage3_in.seek(0xA620)
stage3_in.write(unhexlify(sha256_pay81))
stage3_in.seek(0x0)

with open(stage3, 'rb') as f:
    bytes = f.read()
    sha256_stage3 = hashlib.sha256(bytes).hexdigest()
print("stage3 hash:", sha256_stage3)

bootout.seek(0x11500)
bootout.write(aes_ctr_dec(bytes, s3_key, s3_ctr))
#------------------

#stage2 40008100.bin
stage2_in = open(stage2, "wb")
stage2_in.write(aes_ctr_dec(bootin[0x100:0x110D0], s2_key, s2_ctr))
stage2_in.seek(0x45C0)
stage2_in.write(patch_s2)
stage2_in.seek(0x0)

with open(stage2, 'rb') as f:
    bytes = f.read()
    sha256_stage2 = hashlib.sha256(bytes).hexdigest()
print("stage2 hash:", sha256_stage2)

bootout.seek(0x100)
bootout.write(aes_ctr_dec(bytes, s2_key, s2_ctr))
#-------------------

#header.bin
header_m = open(header, "wb")
header_m.write(bootin[0x0:0xE0])
header_m.seek(0x10)
header_m.write(unhexlify(sha256_stage2))
header_m.seek(0x0)

with open(header, 'rb') as f:
    bytes = f.read()
    sha256_header = hashlib.sha256(bytes).hexdigest()
print("header hash:", sha256_header)
bootout.seek(0x0)
bootout.write(bytes)

bootout.seek(0xE0)
bootout.write(unhexlify(sha256_header))

#------------------

f = open(bootbin, "rb")
bootin = f.read()
bootout = open(boot, "wb")
bootout.write(bootin)
bootout.seek(0xE0)
bootout.write(unhexlify(sha256_header))
f.close()
pay81.close()
stage2_in.close()
stage3_in.close()
header_m.close()
bootout.close()


os.remove("boot.bin")
os.remove("header.bin")
os.remove("payload_81000000.bin")
os.remove("stage2_40008100.bin")
os.remove("stage3_40020000.bin")
os.remove("bootloader_88000000.bin")
os.remove("assets_8804A000.bin")

print("Done!")
